#
# spec file for package broadcom-wl
#
# Copyright (c) 2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define underversion 6_30_223_248
%ifarch x86_64
%define driverarch _64
%else
%define driverarch %{nil}
%endif
Name:           broadcom-wl
Version:        6.30.223.248
Release:        10.1
Summary:        Wireless driver for Broadcom 43xx series of chips
License:        Proprietary
Group:          System/Kernel
Url:            http://www.broadcom.com/support/802.11/linux_sta.php
Source0:        http://www.broadcom.com/docs/linux_sta/hybrid-v35%{driverarch}-nodebug-pcoem-%{underversion}.tar.gz
Source1:        README.SUSE
Source2:        broadcom-wl-blacklist
Patch0:         %{name}-6_30_223_248-linux-4.x.patch 
Patch2:		%{name}-6_30_223_248-disable-timestamps.patch
Patch42:        broadcom-wl-4.2.patch
Patch43:        broadcom-wl-4.3.patch
Patch47:        broadcom-wl-4.7.patch
Patch48:        broadcom-wl-4.8.patch
BuildRequires:  kernel-source
BuildRequires:  kernel-syms
BuildRequires:  module-init-tools
Requires:       broadcom-wl-kmp
Provides:       wl-kmod-common = %{version}
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch:  %ix86 x86_64
%suse_kernel_module_package -p %{_sourcedir}/broadcom-wl-preamble kdump um ec2

%description
These packages contain Broadcom's IEEE 802.11a/b/g/n hybrid Linux®
device driver for use with Broadcom's BCM4311-, BCM4312-, BCM4321-,
and BCM4322-based hardware.

NOTE:           You must read the LICENSE.TXT file  before using this software.

%package KMP
Summary:        Wireless driver for Broadcom 43xx series of chips
Group:          System/Kernel

%description KMP
These packages contain Broadcom's IEEE 802.11a/b/g/n hybrid Linux®
device driver for use with Broadcom's BCM4311-, BCM4312-, BCM4321-,
and BCM4322-based hardware.

NOTE:           You must read the LICENSE.TXT file  before using this software.

%prep
%setup -q -c hybrid-v35%{driverarch}-nodebug-pcoem-%{underversion}
%patch0 -p1
%patch2 -p1
%patch42 -p1
%patch43 -p1
%patch47 -p1
%patch48 -p1

sed -i 's/\r$//' lib/LICENSE.txt

%build
set -- *
mkdir source
mv "$@" source/
mkdir obj

for flavor in %{flavors_to_build}; do
    rm -rf obj/$flavor
    cp -r source obj/$flavor
    make -C %{_prefix}/src/linux-obj/%{_target_cpu}/$flavor modules M=$PWD/obj/$flavor V=1
done

%install
# blacklist
mkdir -p %{buildroot}%{_sysconfdir}/modprobe.d/
mkdir -p %{buildroot}%{_docdir}/%{name}/
install -p -m0644 %{SOURCE2} %{buildroot}/%{_sysconfdir}/modprobe.d/
install -p -m0644 %{SOURCE1} %{buildroot}%{_docdir}/%{name}/
install -p -m0644 source/lib/LICENSE.txt %{buildroot}%{_docdir}/%{name}/

%if 0%{?suse_version} >= 1120
mv %{buildroot}/%{_sysconfdir}/modprobe.d/broadcom-wl-blacklist %{buildroot}/%{_sysconfdir}/modprobe.d/50-broadcom-wl-blacklist.conf
%endif

# Kernel module
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=updates
for flavor in %{flavors_to_build}; do
     make -C %{_prefix}/src/linux-obj/%{_target_cpu}/$flavor modules_install \
        M=$PWD/obj/$flavor
done

%files
%defattr(-,root,root)
%doc %dir %{_docdir}/%{name}
%doc %{_docdir}/%{name}/LICENSE.txt
%doc %{_docdir}/%{name}/README.SUSE
%if 0%{?suse_version} >= 1120
%config(noreplace) %{_sysconfdir}/modprobe.d/50-broadcom-wl-blacklist.conf
%else
%config(noreplace) %{_sysconfdir}/modprobe.d/broadcom-wl-blacklist
%endif

%changelog
* Mon Oct 10 2016 olaf@aepfle.de
- Add broadcom-wl-4.8.patch
* Wed Jul 27 2016 olaf@aepfle.de
- Add broadcom-wl-4.7.patch
* Sat Feb 27 2016 olaf@aepfle.de
- Add broadcom-wl-4.3.patch
* Fri Sep 18 2015 olaf@aepfle.de
- Add broadcom-wl-4.2.patch
* Mon Jun 29 2015 olaf@aepfle.de
- Drop broadcom-wl-6_30_223_248-gcc-49.patch
  Causes compile errors
* Fri May  1 2015 sfalken@cloverleaf-linux.org
- Refactored patch to work with 4.x kernels, maintains backwards
  compatibility with older kernels.
- Dropped:
  + broadcom-wl-6_20_223_248-linux-3.19x.patch
- Added:
  + broadcom-wl-6_20_223_248-linux-4.x.patch
* Thu Mar 26 2015 sfalken@cloverleaf-linux.org
- Reworked patches to work with 3.19.x kernels, combined patches
- Dropped:
  + 0012-add-support-for-Linux-3.15.patch
  + README.SuSE
  + broadcom-wl-248-linux-3.17.x.patch
  + hybrid-v35-nodebug-pcoem-6_30_223_248-disable-timestamps.patch
- Added:
  + README.SUSE
  + broadcom-wl-6_20_223_248-disable-timestamps.patch
  + broadcom-wl-6_20_223_248-gcc-49.patch
  + broadcom-wl-6_20_223_248-linux-3.19x.patch
* Thu Nov 20 2014 i@margueirte.su
- update version 6.30.223.248
  * Upgraded to support 3.11.x.
  * Added wowlan support.
- drop patch:
  * hybrid-v35-nodebug-pcoem-6_30_223_141-linux_recent.patch
- rename patch:
  * hybrid-v35-nodebug-pcoem-6_30_223_141-disable_timestamps.patch
- add patch:
  * broadcom-wl-248-linux-3.17.x.patch
* Tue Jun 24 2014 joerg.lorenzen@ki.tng.de
- Added patch to fix build against kernel >= 3.15.
  Patch taken from http://bazaar.launchpad.net, fixes bln#1307744.
- Added preamble to specify additional rpm tags for kmp subpackages.
* Thu Oct 17 2013 javier@opensuse.org
- Readded time stamp patch
- Renamed patches
- linux recent patch is now applied to any version
* Thu Oct 17 2013 javier@opensuse.org
- Update to 6.30.223.141
  + Upgraded to support 3.8.x
  + Added 4352 support
  + Dropped WEXT support
- Added linux-recent.patch from Arch Linux
- Removed old patches
* Fri Sep  7 2012 oliver.bengs@opensuse.org
- added abiupdate and switch_to to build in openSUSE > 1210
* Sun Nov 13 2011 pascal.bleser@opensuse.org
- fix the LICENSE.txt EOL
- remove build timestamps which cause unnecessary syncs
* Wed Nov  9 2011 javier@opensuse.org
- Update to v5.100.82.112
  + Supports monitor mode
  + Supports cfg80211
  + Supports hidden networks
  + Supports rfkill
  + Issue #72238 - 20%% lower throughput on channels 149, 153, 157, and 161
* Sat Apr 16 2011 pascal.bleser@opensuse.org
- added "brcm80211" to the blacklist
* Fri Mar  4 2011 gber@opensuse.org
- added broadcom-wl-5.100.82.38-fix-linux-2.6.37.patch which fixes
  the build with kernel versions >= 2.6.37 by using sema_init
  instead of init_MUTEX
* Fri Jan 14 2011 andrea@links2linux.de
- update to version 5.10.82.38
  + Support for bcm43227 and bcm43228
  + Fix for issue where iwconfig was sometime reporting rate incorrectly
  + Supports rfkill in kernels 2.6.31 to 2.6.36
  + Supports scan complete event (SIOCGIWSCAN)
  + Adds EAGAIN (busy signal) to query of scan results
  + Following fixes (issues introduced in 5.100.57.13)
    Issue #87477 - 4313: DUT is not able to associate in WPA2-PSK TKIP/AES
    Issue #87533 - NetworkManager: 4313: Unable to associate to APs with WPA2-PSK
  + 4313 PHY fixes to improve throughput stability at different ranges
  + Fix for interop issues with different APs
  + Fix for hangs seen during Fn-F2 sequence
  - Support for rfkill in kernels 2.6.31 to 2.6.36
* Wed Nov  3 2010 alinm.elena@gmail.com
- updated to the version v5.60.246.2
- added the next patch to make it build for 2.6.34 and older kernels
- no need for the autoconf patched anymore
* Wed Aug 18 2010 andrea@links2linux.de
- fixed building on kernel >= 2.6.35
* Mon Jun 28 2010 andrea@opensuse.org
- added broadcom-wl_autoconf.patch to build on suse 11.3 kernel
* Fri Feb 19 2010 javier@opensuse.org
- updated to 5.60.48.36
* Tue Oct 27 2009 andrea@opensuse.org
- new upstream version 5.10.91.9.3
- removed previous patches now upstream
* Thu May  7 2009 Andrea Florio <andrea@links2linux.de> 5.10.91.9 6.pm.13
- new upstream version
- ISSUES FIXED IN THIS RELEASE: #72138 - SLED11 / Ubuntu 8.04: 43224 fails to associate after 6 hours
- KNOWN ISSUES AND LIMITATIONS:
  [#72238] - 20%%%% lower throughput on channels 149, 153, 157, and 161
  [#72324] - Ubuntu 8.04: cannot ping when Linux STA is IBSS creator with WEP enabled
  [#72216] - Ubuntu 8.04: standby/resume with WPA2 and wpa_supplicant causes a continuous assoc/disassoc loop
    (issue with wpa_supplicant, restarting wpa_supplicant fixes the issue)
* Fri Apr 10 2009 Andrea Florio <andrea@links2linux.de> 5.10.79.10 6.pm.10
- added new patch (wpa enterprise hang)
- rebuilt on new kernel
* Sat Mar 14 2009 Andrea Florio <andrea@links2linux.de> 5.10.79.10 5.pm.8
- new upstream version 5.10.79.10
* Sun Mar  1 2009 Andrea Florio <andrea@links2linux.de> 5.10.27.14 5.pm.7
- diabled hidden network patch on suse <= 10.3, it have to be fixed or make fail
* Sun Feb  1 2009 Andrea Florio <andrea@links2linux.de> 5.10.27.14 5.pm.3
- added hidden network patch: http://worldofxor.blogspot.com/2008/12/it-works-broadcom-official-wireless.html
* Wed Jan 28 2009 Andrea Florio <andrea@links2linux.de> 5.10.27.14 5.pm.2
- new upstream version 5.10.27.14
* Sun Jan  4 2009 Andrea Florio <andrea@links2linux.de> 5.10.27.12 5.pm.0
- new upstream version 5.10.27.12
- This update from Broadcom has a new binary blob
- better locking and protection against the interrupt handler
-abstracted the ioctl code for kernels newer then 2.6.26.x
* Mon Dec 15 2008 Andrea Florio <andrea@links2linux.de> 5.10.27.11 5.pm.0
- new upstram version 5.10.27.11
- removed broadcom-wl-ssh_fix.patch
- ported patch  broadcom-wl-kernel-5.10.27.11_2_6_27.patch to new version
* Thu Dec  4 2008 Andrea Florio <andrea@links2linux.de> 5.10.27.6 4.pm.0
- added patch to build on kernel 2.6.27
- added patch to fix ssh issues
* Thu Dec  4 2008 Andrea Florio <andrea@links2linux.de> 5.10.27.6
- Fixed spec file
- build on x86_64
- added readme, license and blacklist file
